summaryrefslogtreecommitdiffstats
path: root/kea
diff options
context:
space:
mode:
Diffstat (limited to 'kea')
-rw-r--r--kea/Makefile80
-rw-r--r--kea/bin/kea-json29
-rwxr-xr-xkea/bin/kea-leases-reset58
3 files changed, 167 insertions, 0 deletions
diff --git a/kea/Makefile b/kea/Makefile
new file mode 100644
index 0000000..49377eb
--- /dev/null
+++ b/kea/Makefile
@@ -0,0 +1,80 @@
+# Open Infrastructure: service-tools
+
+# Copyright (C) 2014-2023 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+SHELL := sh -e
+
+SCRIPTS = bin/*
+
+all: build
+
+test:
+ @echo -n "Checking for syntax errors with sh... "
+ @for SCRIPT in $(SCRIPTS); \
+ do \
+ sh -n $${SCRIPT}; \
+ echo -n "."; \
+ done
+ @echo " done."
+
+ @echo -n "Checking for bashisms... "
+ @if [ -x /usr/bin/checkbashisms ]; \
+ then \
+ for SCRIPT in $(SCRIPTS); \
+ do \
+ checkbashisms -f -x $${SCRIPT}; \
+ echo -n "."; \
+ done; \
+ else \
+ echo "Note: devscripts not installed, skipping checkbashisms."; \
+ fi
+ @echo " done."
+
+ @echo -n "Checking with shellcheck... "
+ @if [ -x /usr/bin/shellcheck ]; \
+ then \
+ for SCRIPT in $(SCRIPTS); \
+ do \
+ shellcheck -e SC2039 $${SCRIPT}; \
+ echo -n "."; \
+ done; \
+ else \
+ echo "Note: shellcheck not installed, skipping shellcheck."; \
+ fi
+ @echo " done."
+
+build:
+
+install: build
+ mkdir -p $(DESTDIR)/usr/bin
+ cp -r bin/* $(DESTDIR)/usr/bin
+
+uninstall:
+ for FILE in bin/*; \
+ do \
+ rm -f $(DESTDIR)/usr/bin/$$(basename $${FILE}); \
+ done
+ rmdir --ignore-fail-on-non-empty --parents $(DESTDIR)/usr/bin || true
+
+ rmdir --ignore-fail-on-non-empty --parents $(DESTDIR) || true
+
+clean:
+
+distclean:
+
+reinstall: uninstall install
diff --git a/kea/bin/kea-json b/kea/bin/kea-json
new file mode 100644
index 0000000..9380a3c
--- /dev/null
+++ b/kea/bin/kea-json
@@ -0,0 +1,29 @@
+curl -X POST -H "Content-Type: application/json" -d '{ "command": "lease4-get", "arguments": { "subnet-id": 152, "ip-address": "147.87.152.14"}, "service": [ "dhcp4" ] }' http://localhost:8000/ | jq
+
+··curl -X POST -H "Content-Type: application/json" -d '{ "command": "config-reload", "service": [ "dhcp4" ] }' http://localhost:8000/
+»·······»·······curl -X POST -H "Content-Type: application/json" -d '{ "command": "config-reload", "service": [ "dhcp6" ] }' http://localhost:8000/
+»·······»·······curl -X POST -H "Content-Type: application/json" -d '{ "command": "config-reload", "service": [ "d2" ] }' http://localhost:8000/
+
+
+
+
+- man muss immer die subnet id mitgeben
+- mac adressen als identifier sind nur in ipv4 erlabut, nicht in ipv6
+
+mein beispiel:
+
+# get a lease6
+curl -X POST -H "Content-Type: application/json" -d '
+{ "command": "lease6-get", "arguments": { "subnet-id": 601000054,
+"ip-address": "2a07:6b41:18:12:15:0:1:9"}, "service": [ "dhcp6" ] }'
+http://localhost:8000/ | jq
+
+# delete lease6
+curl -X POST -H "Content-Type: application/json" -d '
+{ "command": "lease6-del", "arguments": { "subnet-id": 601000054,
+"ip-address": "2a07:6b41:18:12:15:0:1:9"}, "service": [ "dhcp6" ] }'
+http://localhost:8000/ | jq
+
+docu:
+
+https://kea.readthedocs.io/en/latest/arm/hooks.html#libdhcp-lease-cmds-so-lease-commands-for-easier-lease-management
diff --git a/kea/bin/kea-leases-reset b/kea/bin/kea-leases-reset
new file mode 100755
index 0000000..f1e4d91
--- /dev/null
+++ b/kea/bin/kea-leases-reset
@@ -0,0 +1,58 @@
+#!/bin/sh
+
+# Open Infrastructure: service-tools
+
+# Copyright (C) 2014-2023 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+HOSTS="${*:-localhost}"
+
+for HOST in ${HOSTS}
+do
+ case "${HOST}" in
+ localhost)
+ echo "Removing all leases..."
+
+ sudo service kea-dhcp6-server stop
+ sudo service kea-dhcp4-server stop
+
+ sudo rm -f /var/lib/kea/*.csv*
+
+ sudo service kea-dhcp6-server start
+ sudo service kea-dhcp4-server start
+
+ echo
+ echo "done."
+ ;;
+
+ *)
+ echo "'${HOST}': Removing all leases..."
+
+ ssh "${HOST}" \
+ "sudo service kea-dhcp6-server stop; \
+ sudo service kea-dhcp4-server stop; \
+ sudo rm -f /var/lib/kea/*.csv*; \
+ sudo service kea-dhcp6-server start; \
+ sudo service kea-dhcp4-server start"
+
+ echo
+ echo "done."
+ ;;
+ esac
+done